package no.ntnu.idatt1002.demo.data.Economics;

import no.ntnu.idatt1002.demo.data.Economics.Income;
import no.ntnu.idatt1002.demo.data.Economics.IncomeCategory;
import no.ntnu.idatt1002.demo.data.Economics.IncomeOverview;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.DisplayName;
import org.junit.jupiter.api.Test;

import static org.junit.jupiter.api.Assertions.*;

public class IncomeOverviewTest {
    IncomeOverview incomeOverview;

    @BeforeEach
    public void createItemOverView(){
        incomeOverview = new IncomeOverview();
    }
    @Test
    @DisplayName("addItem method throws exception when it should")
    void addItemThrows(){
        Income income = new Income("description", 59.9f, false, IncomeCategory.SALARY, "03.03.23");
        assertThrows(IllegalArgumentException.class, () -> {incomeOverview.addItem(income); incomeOverview.addItem(income);});
    }

    @Test
    @DisplayName("addItem method does not throw exception when it should not")
    void addItemDoesNotThrow(){
        Income expense = new Income("description", 59.9f, false, IncomeCategory.GIFT, "03.03.23");
        Income income = new Income("anotherDescription", 6.5f, true, IncomeCategory.SALARY, "02.03.23");
        assertDoesNotThrow(() -> {incomeOverview.addItem(expense); incomeOverview.addItem(income);});
    }

    @Test
    @DisplayName("getTotalSum method gives correct amount")
    void getTotalSumCorrectAmount(){
        incomeOverview.addItem(new Income("description1", 59.9f, false, IncomeCategory.SALARY, "03.03.23"));
        incomeOverview.addItem(new Income("description2", 62.4f, true, IncomeCategory.GIFT, "01.02.21"));
        incomeOverview.addItem(new Income("description3", 9.81f, false, IncomeCategory.SALARY, "05.07.23"));
        double totalIncome = 59.9f + 62.4f + 9.81f;
        assertEquals(Math.round(incomeOverview.getTotalSum()), Math.round(totalIncome));
    }
}